local nodeType = node.nodeType
local nodeName = node.nodeName
local append = node.append

function node.text(X)
   for i=1,#X do
      if nodeType(X[i]) == 'text' then
         return X[i]
      end
   end
   return append(X, xml.TEXT, '')
end

function node.setText(X, T)
   X:text():setInner(T)
end

function node.setAttr(N, K, V)
   if nodeType(N) ~= 'element' then
      error('Must be an element')
   end
   if not N[K] or nodeType(N[K]) ~= 'attribute' then
      append(N, xml.ATTRIBUTE, K)
   end 
   N[K] = V
   return N
end

function xml.findElement(X, Name)
   if nodeName(X) == Name then
      return X
   end
   for i = 1, #X do
      local Y = xml.findElement(X[i], Name)
      if Y then return Y end
   end
   return nil
end

function node.addElement(X, Name)
   return append(X, xml.ELEMENT, Name)
end